var platformInfo = document.getElementById('platfornm-info');
// platformInfo.textContent = 'v' + WebAgent.version;

/* 显示的平台信息 */
var search = window.location.search.substring(1),
    pairs = search.split('&'), pair,
    searchMap = {}, i, type;

for (i = pairs.length; i--;) {
  pair = pairs[i].split('=');
  searchMap[pair[0]] = pair[1];
}

switch (searchMap.type) {
  case 'ocx':
    type = 'ocx';
    if (platform.name !== 'IE') _triggerDOM('tip-use-exe', true);
    break;
  case 'exe':
  case 'websocket':
  default:
    type = 'websocket';
    if (platform.name === 'IE' && parseFloat(platform.version) < 10) _triggerDOM('tip-use-ocx', true);
    break;
}

var webAgent = new WebAgent(type);
WebAgent.logger.info('platform info: %s %s %s', platform.name, platform.version, platform.os);
// 每次收到消息时重新赋值为消息发送者id
let guestId = ''
// 存放示忙示闲状态，用于在通话结束后恢复原有状态
let busyState = true

webAgent.oncheckstatechange = function (state) {
  switch (state) {
    case 0:   //  checkout
      toolbarChangeState(TOOLBAR_STATE.CHECKOUT);
      pageReset();
      break;
    case 1:   //  checking
      toolbarChangeState(TOOLBAR_STATE.CHECKING);
      break;
    case 2:   //  checked
      SDK_STATE.isCheckin = false;
      toolbarChangeState(TOOLBAR_STATE.CHECKED);
      break;
    case 3:   // checkout
      toolbarChangeState(TOOLBAR_STATE.CHECKOUT);
      break;
  }
};
webAgent.ononlinemessagesendresult=function (succ) { 
   alert('发送消息'+succ);
   console.log('ononlinemessagesendresult', succ); 

};

webAgent.ononlinemessagerecvnotify      = function (content, userId) { 
  alert('收到消息'+content);
  console.log('ononlinemessagerecvnotify', content, userId); 
  
};

webAgent.onconferencemessagesendresult=function (result) { 
  alert(result);
  console.log('onconferencemessagesendresult', result); 

};
webAgent.oncallstatechange = function (type, extraString, reason) {
  switch (type) {
    case 0:   //  incoming
      toolbarChangeState(TOOLBAR_STATE.INCOMING);
      break;
    case 1:   //  talking
      SDK_STATE.isTalking = true;
      toolbarChangeState(TOOLBAR_STATE.TALKING);
      break;
    case 2:   //  termed
      if (SDK_STATE.isTalking === true) SDK_STATE.servicedCount++;
      SDK_STATE.isTalking = false;
      document.getElementById('call-type-span').innerHTML = '切换音频'
      updateServicedCount();
      toolbarChangeState(TOOLBAR_STATE.TERM);
      callReset();
      changeHoldButton(true)
      clearMessage()
      clearUrgent()
      break;
  }
};
webAgent.onapplyresult = function (applyId, pause, succ) {
  if (pause) {
    toolbarChangeState(TOOLBAR_STATE.BUSY);
  } else {
    toolbarChangeState(TOOLBAR_STATE.IDLE);
  }
};
webAgent.onwaitcountnotify = function (count) {
  if (typeof count === 'number') count = count.toString(10);
  info.waitCount.textContent = count;
};
webAgent.ongetversionresult = function (version) {
  document.getElementById('version').textContent = version;
};
webAgent.onsnapshotresult = function (succ, base64, fileName) {
  SDK_STATE.snapshotInfo.fileName = fileName;
  SDK_STATE.snapshotInfo.base64 = base64;

  _triggerDOM('show-snapshot', true);
  base64 = 'data:image/gif;base64,' + base64;
  document.getElementById('snapshot-image').src = base64;
};
webAgent.onlocalrecordnotify = function(isRecording) {
  SDK_STATE.enableLocalRecord = isRecording;
  if (SDK_STATE.enableLocalRecord) {
    button.localReload.getElementsByTagName('img')[0].src = 'static/images/local-record-enable.png';
  } else {
    button.localReload.getElementsByTagName('img')[0].src = 'static/images/local-record.png';
  }
};
webAgent.ontransferresult = function (result) {
  alertDialog('提示', '转接' + (result ? '成功' : '失败'));
};
webAgent.onscreenshareresult = function (start,shareUserId) {
  SDK_STATE.enableDesktopShare = start;
  agentId = webAgent.getAgentId();
  guestId = webAgent.getGuestId();
    if(SDK_STATE.enableDesktopShare && shareUserId == agentId){
	button.screenShare.getElementsByTagName('img')[0].src = 'static/images/desktop-share-enable.png';
	triggerDisabled(button.sign, true);
    }else if(SDK_STATE.enableDesktopShare && shareUserId != agentId){
	button.screenShare.getElementsByTagName('img')[0].src = 'static/images/desktop-share.png';
	triggerDisabled(button.screenShare, true);
	triggerDisabled(button.sign, true);
	}else{
    button.screenShare.getElementsByTagName('img')[0].src = 'static/images/desktop-share.png';
	triggerDisabled(button.sign, false);
	triggerDisabled(button.screenShare, false);
	}
  };
webAgent.onwatchnetworkspeednotify = function (upload, download) {
  networkSpeed.uploadSpeed.textContent = Math.floor(upload / 1024 * 100) / 100 + 'k/s';
  networkSpeed.downloadSpeed.textContent = Math.floor(download / 1024 * 100) / 100 + 'k/s';
}
webAgent.ontextmessagerecvnotify = function (userId, content) {
  guestId = userId
  _triggerDOM('message-dialog', true)
  topMostDialog('message-dialog')

  document.getElementById('message-container').appendChild(createMessage(false, content))
}
webAgent.oncalltypeturnednotify = function (callType) {
  document.getElementById('call-type-span').innerHTML = callType === 0 ? '切换视频' : '切换音频'
}
webAgent.onurgentrequestrecvnotify = function (serialNumber, userId) {
  _triggerDOM('urgent-dialog', true)
  addUrgentList(serialNumber, userId)
}
var THEME_COLOR = {
  RED: 'rgb(217, 0, 27)',
  YELLOW: 'rgb(245, 154, 35)',
  GREEN: 'rgb(149, 242, 4)'
};

var TOOLBAR_STATE = {
  CHECKOUT: 'checkout',
  CHECKING: 'checking',
  CHECKED: 'checked',
  TALKING: 'talking',
  TERM: 'term',
  IDLE: 'idle',
  INCOMING: 'incoming',
  BUSY: 'busy'
};
var TOOLBAR_STATE_PROPS = {};
TOOLBAR_STATE_PROPS[TOOLBAR_STATE.CHECKOUT] = {label: '●已签出', color: THEME_COLOR.RED};
TOOLBAR_STATE_PROPS[TOOLBAR_STATE.CHECKING] = {label: '●签入中...', color: THEME_COLOR.YELLOW};
TOOLBAR_STATE_PROPS[TOOLBAR_STATE.TALKING] = {label: '●通话中', color: THEME_COLOR.RED};
TOOLBAR_STATE_PROPS[TOOLBAR_STATE.BUSY] = {label: '●忙碌', color: THEME_COLOR.RED};
TOOLBAR_STATE_PROPS[TOOLBAR_STATE.IDLE] = {label: '●空闲', color: THEME_COLOR.GREEN};

var SDK_STATE = {
  enableLocalRecord: false,
  enableDesktopShare: false,
  requirementsChecked: false,
  agentInfo: {
    userId: null,
    password: null,
    server: null,
    busy: false
  },
  servicedCount: 0,
  snapshotInfo: {
    fileName: null,
    base64: null
  },
  isTalking: false,
  isCheckin: false
};

var stateDOM = document.getElementById('state');
var button = {
  check: document.getElementById('check-button'),
  answer: document.getElementById('answer-button'),
  end: document.getElementById('end-button'),
  snapshot: document.getElementById('snapshot'),
  localReload: document.getElementById('local-reload'),
  transferCall: document.getElementById('transfer-call'),
  invite: document.getElementById('invite'),
  screenShare: document.getElementById('screen-share'),
  apply: document.getElementById('apply-button'),
  sign: document.getElementById('sign-button')
};
var info = {
  userId: document.getElementById('userId'),
  serviceCount: document.getElementById('service-count'),
  onlineIdleCount: document.getElementById('online-idle-count'),
  onlineTalkingCount: document.getElementById('online-talking-count'),
  waitCount: document.getElementById('wait-count'),
  state: document.getElementById('state')
};
var dialog = {
  selectSnapshot: document.getElementById('select-snapshot'),
}
var networkSpeed = {
  uploadSpeed: document.getElementById('upload-speed'),
  downloadSpeed: document.getElementById('download-speed')
};

init();
/**
 * @desc 页面初始化时执行，暂时使用 `websocket` 模式
 * @ignore
 */
function init() {
  var loadingMaskTextTipDOM = document.getElementById('loading-mask-text-tip'),
      notFoundPluginTipsDOM = document.getElementById('not-found-plugin-tips');

  notFoundPluginTipsDOM.style.display = 'none';
  loadingMaskTextTipDOM.textContent = '正在检测插件...';

  toolbarChangeState(TOOLBAR_STATE.CHECKOUT);
  webAgent.init()
    .then(function () {
      SDK_STATE.requirementsChecked = true;
      var uninstallPluginTipsDOM = document.getElementById('uninstall-plugin-tips');
      uninstallPluginTipsDOM.parentElement.removeChild(uninstallPluginTipsDOM);
      removeLoadingMask();
      // var loadingMaskDOM = document.getElementById('loading-mask');
      // loadingMaskDOM.parentElement.removeChild(loadingMaskDOM);
      webAgent.getVersion();
      webAgent.watchNetWorkSpeed(true);
    })
    ['catch'](function (e) {
      var notFoundPluginTipsDOM = document.getElementById('not-found-plugin-tips');
      notFoundPluginTipsDOM.style.display = 'block';
      var loadingMaskTextDOM = document.getElementById('loading-mask'),
        loadingMaskTextTipDOM = document.getElementById('loading-mask-text-tip');
      loadingMaskTextTipDOM.textContent = '检测失败，请重新检测或下载安装插件。';
      // setTimeout(function () {
      //   console.log(document.getElementById('loading-mask'))
      //   var loadingMaskDOM = document.getElementById('loading-mask');
      //   loadingMaskDOM.parentElement.removeChild(loadingMaskDOM);
      // }, 1000);
    });
}

function sendConferenceMessage(type, content, userId){
	webAgent.sendConferenceMessage(type, content, userId);
}

function setThemeColor(color){
	console.log(color);
	webAgent.setThemeColor(color);
}

function Destory(){
	webAgent.destroy();
}

function InitA(){
	webAgent.InitA();
}
function sendOnlineMessage(userId, content){
	webAgent.sendOnlineMessage(userId, content);
}

function setMainWindowFrame(type, x, y, width, height){
	webAgent.setMainWindowFrame(type, x, y, width, height);
	
}
function removeLoadingMask() {
  var loadingMaskDOM = document.getElementById('loading-mask');
  loadingMaskDOM.parentElement.removeChild(loadingMaskDOM);
}
function toolbarChangeState(state) {
  var textContent, color;
  const redClass = 'agent-login-button-red'
  let classList
  switch (state) {
    case TOOLBAR_STATE.CHECKOUT:    //  未登录: 已签出
      textContent = TOOLBAR_STATE_PROPS[TOOLBAR_STATE.CHECKOUT].label;
      color = TOOLBAR_STATE_PROPS[TOOLBAR_STATE.CHECKOUT].color;
      button.check.innerHTML = '登录'
      button.check.classList.remove(redClass)
      triggerDisabled(button.apply, true)
      triggerDisabled(button.check, false)
      triggerDisabled(button.answer, true);
      triggerDisabled(button.end, true);
      break;
    case TOOLBAR_STATE.CHECKING:    //  正在登录: 签入中
      textContent = TOOLBAR_STATE_PROPS[TOOLBAR_STATE.CHECKING].label;
      color = TOOLBAR_STATE_PROPS[TOOLBAR_STATE.CHECKING].color;
      button.check.innerHTML = '登出'
      classList = button.check.classList
      if (!classList.contains(redClass)) {
        classList.add(redClass)
      }
      triggerDisabled(button.answer, true);
      triggerDisabled(button.check, false)
      triggerDisabled(button.end, true);
      break;
    case TOOLBAR_STATE.CHECKED:
      textContent = TOOLBAR_STATE_PROPS[TOOLBAR_STATE.BUSY].label;
      color = TOOLBAR_STATE_PROPS[TOOLBAR_STATE.BUSY].color;
      button.check.innerHTML = '登出'
      classList = button.check.classList
      if (!classList.contains(redClass)) {
        classList.add(redClass)
      }
      button.apply.innerHTML = '示闲'
      busyState = true
      triggerDisabled(button.check, false)
      triggerDisabled(button.apply, false)
      break
    case TOOLBAR_STATE.TALKING:     //  通话中
      textContent = TOOLBAR_STATE_PROPS[TOOLBAR_STATE.TALKING].label;
      color = TOOLBAR_STATE_PROPS[TOOLBAR_STATE.TALKING].color;
      triggerDisabled(button.answer, true);
      triggerDisabled(button.end, false);
      triggerDisabled(button.apply, true);
      break;
    case TOOLBAR_STATE.TERM:
      triggerDisabled(button.answer, true);
      triggerDisabled(button.end, true);
      triggerDisabled(button.apply, false);
	  triggerDisabled(button.sign, false);
	  triggerDisabled(button.screenShare, false);
      if (busyState) {
        textContent = TOOLBAR_STATE_PROPS[TOOLBAR_STATE.BUSY].label;
        color = TOOLBAR_STATE_PROPS[TOOLBAR_STATE.BUSY].color;
      } else {
        textContent = TOOLBAR_STATE_PROPS[TOOLBAR_STATE.IDLE].label;
        color = TOOLBAR_STATE_PROPS[TOOLBAR_STATE.IDLE].color;
      }
      break
    case TOOLBAR_STATE.INCOMING:
      textContent = TOOLBAR_STATE_PROPS[TOOLBAR_STATE.TALKING].label;
      color = TOOLBAR_STATE_PROPS[TOOLBAR_STATE.TALKING].color;
      triggerDisabled(button.apply, true);
      triggerDisabled(button.answer, false);
      triggerDisabled(button.end, false);
      break;
    case TOOLBAR_STATE.IDLE:        //  空闲
      textContent = TOOLBAR_STATE_PROPS[TOOLBAR_STATE.IDLE].label;
      color = TOOLBAR_STATE_PROPS[TOOLBAR_STATE.IDLE].color;
      button.apply.innerHTML = '示忙'
      busyState = false
      break;
    case TOOLBAR_STATE.BUSY:
      textContent = TOOLBAR_STATE_PROPS[TOOLBAR_STATE.BUSY].label;
      color = TOOLBAR_STATE_PROPS[TOOLBAR_STATE.BUSY].color;
      button.apply.innerHTML = '示闲'
      busyState = true
      break
  }
  if (textContent) {
    info.state.textContent = textContent;
    info.state.style.color = color;
  }
}

function checkin(userId, password, server) {
  SDK_STATE.agentInfo.userId = userId;
  SDK_STATE.agentInfo.password = password;
  SDK_STATE.agentInfo.server = server;
  SDK_STATE.agentInfo.busy = false;
  info.userId.textContent = SDK_STATE.agentInfo.userId;
  webAgent.checkin(userId, password, server);
}

function checkout() {
  alertDialog('提示', '是否确认登出？', function () {
    webAgent.checkout();
  }, function () {
    document.getElementById('check-button').disabled = false
  });
}

function answer() {
  webAgent.answer();
}

function end() {
  webAgent.end();
}

function snapshot() {
  triggerSelectSnapshot(true);
}

function localRecord() {
  if (SDK_STATE.enableLocalRecord) {
    topMostDialog('local-record-dialog')
    webAgent.localRecord(false);
  } else {
    _triggerDOM('local-record-dialog', true);
    topMostDialog('local-record-dialog')
  }
}

function transferCall() {
  showTransferCall();
}

function invite() {
  showInvite();
}

function desktopShare() {
  webAgent.enableDesktopShare(!SDK_STATE.enableDesktopShare);
}

function triggerDisabled(dom, disabled) {
  if (disabled) {
    dom.setAttribute('style', 'background-color: rgb(170, 170, 170);');
    dom.setAttribute('disabled', true);
  } else {
    dom.removeAttribute('style');
    dom.removeAttribute('disabled');
  }
}

var snapshotList = [];
function triggerSelectSnapshot(visible) {
  if (visible) {
    var selectDOM = document.getElementById('selected-snapshot-item'), i, option;

    selectDOM.innerHTML = '';

    webAgent.ongetsnapshotlistresult = function (list) {
      _triggerDOM('select-snapshot', true);
      snapshotList = list;
      for (i = 0; i < list.length; i++) {
        option = document.createElement('option');
        selectDOM.options.add(new Option(list[i].DisplayName, list[i].RenderId));
      }
    }
    topMostDialog('select-snapshot')
    webAgent.getSnapshotList();
  } else {
    _triggerDOM('select-snapshot', false);
  }
}

function selectSnapshotItem() {
  var selectDOM = document.getElementById('selected-snapshot-item'), i, item = snapshotList[selectDOM.selectedIndex];
  triggerSelectSnapshot(false);
  webAgent.snapshot(item.RenderId);
}

function triggerToolbarSettings() {
  _triggerDOM('toolbar-settings');
}

function selectResolution() {
  var select = document.getElementById('select-resolution'), index = select.selectedIndex, value = select.value;
  webAgent.changeResolution(parseInt(value));
}

function updateServicedCount() {
  info.serviceCount.textContent = SDK_STATE.servicedCount;
}

function confirmSnapshot() {
  _triggerDOM('show-snapshot', false);
  webAgent.saveImage(SDK_STATE.snapshotInfo.base64);
}

function cancelSnapshot() {
  _triggerDOM('show-snapshot', false);
}

function confirmLocalRecord() {
  var fps = parseInt(_getValue('local-reload-fps'));
  var bitrate = parseInt(_getValue('local-reload-bitrate'));
  var resolutionWidth = parseInt(_getValue('local-reload-resolution-width'));
  var resolutionHeight = parseInt(_getValue('local-reload-resolution-height'));
  var selfRecord = _getCheckboxValue('local-reload-self-record');

  if(isNaN(fps) || isNaN(bitrate) || isNaN(resolutionWidth) || isNaN(resolutionHeight)){
    alert('请输入正确的帧率、码率、分辨率')
    return
  }

  _triggerDOM('local-record-dialog', false);
  webAgent.localRecord(true, fps, bitrate, resolutionWidth, resolutionHeight, selfRecord);
}

function cancelLocalRecord() {
  _triggerDOM('local-record-dialog', false);
}

var groupList = [];
function showTransferCall() {
  renderGroupList('selected-transfer-call-group-item', function () {
    renderAgentSelect(document.getElementById('selected-transfer-call-group-item'), 'selected-transfer-call-agent-item', true);
    _triggerDOM('transfer-call-dialog', true);
    topMostDialog(('transfer-call-dialog'));
  });
}

function showInvite() {
  renderGroupList('selected-invite-group-item', function () {
    renderAgentSelect(document.getElementById('selected-invite-group-item'), 'selected-invite-agent-item', false);
    _triggerDOM('invite-dialog', true);
    topMostDialog('invite-dialog')
  });
}

var agentList = [];
function renderAgentSelect(groupSelect, selectId, hasDefault) {
  var selectDOM = document.getElementById(selectId),
      group = groupList[groupSelect.selectedIndex],
      i, option;

  selectDOM.innerHTML = '';
  if (hasDefault) {
    option = document.createElement('option');
    selectDOM.options.add(new Option('默认', '-1'));
  }

  webAgent.queryAvailableAgents(group);
  webAgent.onqueryavailableagentsresult = function (succ, list) {
    if (!succ) return;
    agentList = list;
    for (i = 0; i < list.length; i++) {
      option = document.createElement('option');
      selectDOM.options.add(new Option(list[i], list[i]));
    }
  }
}

function confirmSelect(groupId, agentId, dialogId, type) {
  var groupItem = document.getElementById(groupId),
      agentItem = document.getElementById(agentId),
      group = groupList[groupItem.selectedIndex],
      agent = type === 'invite' ? agentList[agentItem.selectedIndex] : agentList[agentItem.selectedIndex - 1];

  /* 取值后初始化 */
  groupItem.innerHTML = '';
  agentItem.innerHTML = '';

  _triggerDOM(dialogId, false);

  switch (type) {
    case 'transferCall':
      if (notUAN(agent)) {
        webAgent.transferCallToAgent(agent);
      } else {
        webAgent.transferCallToGroup(group);
      }
      break;
    case 'invite':
      if (notUAN(agent)) webAgent.invite(agent);
  }
}

function cancelSelect(groupId, agentId, dialogId) {
  var groupItem = document.getElementById(groupId),
      agentItem = document.getElementById(agentId);

  groupItem.innerHTML = '';
  agentItem.innerHTML = '';

  _triggerDOM(dialogId, false);
}

function renderGroupList(selectId, callback) {
  var selectDOM = document.getElementById(selectId), i, option;

  selectDOM.innerHTML = '';

  webAgent.queryGroups();
  webAgent.onquerygroupsresult = function (succ, list) {
    if (!succ) return;
    groupList = list;
    for (i = 0; i < list.length; i++) {
      option = document.createElement('option');
      selectDOM.options.add(new Option(list[i], list[i]));
    }

    selectDOM.selectIndex = 0;
    callback();
  }
}

function _triggerDOM(id, visible) {
  var dom = document.getElementById(id), display = dom.style.display;
  if (!notUAN(visible)) {
    dom.style.display = display === 'none' ? 'block' : 'none';
  } else {
    if (visible) {
      dom.style.display = 'block';
    } else {
      dom.style.display = 'none';
    }
  }
}

function pageReset() {
  SDK_STATE.servicedCount = 0;
  updateServicedCount();
  info.userId.textContent = '未知';
  info.waitCount.textContent = '0';
  toolbarChangeState(TOOLBAR_STATE.CHECKOUT);
  callReset();
}

function callReset() {
  SDK_STATE.enableDesktopShare = false;
  button.screenShare.getElementsByTagName('img')[0].src = 'static/images/desktop-share.png';
}

function _getValue(id) {
  return document.getElementById(id).value;
}

function _getCheckboxValue(id) {
  return document.getElementById(id).checked;
}

function notUAN(variable) {
  return variable !== null && variable !== undefined;
}

function alertDialog(title, content, success, cancel) {
  alertDialog.success = success;
  alertDialog.cancel = cancel
  var titleDOM = document.getElementById('dialog-mask-title'),
      contentDOM = document.getElementById('dialog-mask-content');

  titleDOM.textContent = title;
  contentDOM.textContent = content;

  _triggerDOM('dialog-mask', true);
}

function confirmAlert() {
  if (alertDialog.success) alertDialog.success();
  cancelAlert(true);
}

function cancelAlert(fromConfirm) {
  if (!fromConfirm) {
    if (alertDialog.cancel) alertDialog.cancel();
  }
  _triggerDOM('dialog-mask', false);

  var titleDOM = document.getElementById('dialog-mask-title'),
    contentDOM = document.getElementById('dialog-mask-content');

  titleDOM.textContent = '';
  contentDOM.textContent = '';
}

function hold () {
  const span = document.getElementById('hold-span')
  if (span.innerHTML === '会话保持') {
    webAgent.hold(true)
    changeHoldButton(false)
  } else {
    webAgent.hold(false)
    changeHoldButton(true)
  }
}

function showMessage (show) {
  _triggerDOM('message-dialog', show)
  topMostDialog('message-dialog')
}

function send () {
  const app = document.getElementById('message-container')
  const input = document.getElementById('message')
  const value = input.value
  input.value = ''
  app.appendChild(createMessage(true, value))
  if (app.scrollTo) {
    app.scrollTo(0, app.scrollHeight)
  } else {
    app.scrollTop = app.scrollHeight
  }

  webAgent.sendTextMessage('', value)
}

function createMessage (sendOrReceive, content) {
  const messageAndName = document.createElement('div')
  messageAndName.style.display = 'flex'
  messageAndName.style.alignItems = 'flex-start'
  messageAndName.style.float = sendOrReceive ? 'right' : 'left'
  messageAndName.style.margin = '5px 1px'
  messageAndName.style.width = '80%'

  const message = document.createElement('div')
  message.style.display = 'inline-block'
  message.style.overflowWrap = 'break-word'
  message.style.padding = '5px 10px'
  message.style.backgroundColor = sendOrReceive ? '#c9e7ff' : '#eee'
  message.style.width = '80%'
  message.appendChild(document.createTextNode(content))

  const name = document.createElement('div')
  name.style.display = 'inline-block'
  name.style.margin = '1px'
  name.style.maxWidth = '30%'
  name.style.overflowWrap = 'break-word'
  // name.style.overflowX = 'hide'
  name.appendChild(document.createTextNode(sendOrReceive ? '我' : guestId))

  if (sendOrReceive) {
    messageAndName.appendChild(message)
    messageAndName.appendChild(name)
  } else {
    messageAndName.appendChild(name)
    messageAndName.appendChild(message)
  }

  return messageAndName
}

function keyDown() {
  if (event.keyCode === 13) {
    send()
  }
}

function sign() {
  webAgent.sign('')
}

function turnCallType() {
  const span = document.getElementById('call-type-span')
  if (span.innerHTML === '切换音频') {
    span.innerHTML = '切换视频'
    webAgent.turnCallType(0)
  } else {
    span.innerHTML = '切换音频'
    webAgent.turnCallType(1)
  }
}

function mute () {
  const button = document.getElementById('mute-button')
  if (button.innerHTML === '静音') {
    webAgent.mute(true)
    button.innerHTML = '取消静音'
  } else {
    webAgent.mute(false)
    button.innerHTML = '静音'
  }
}

function showUrgent(show) {
  _triggerDOM('urgent-dialog', show)
  topMostDialog('urgent-dialog')
}

function addUrgentList(serialNumber, userId) {
  const list = document.getElementById('urgent-list')

  const li = document.createElement('li')
  const pre = document.createElement('pre')
  const text = document.createTextNode(userId)
  pre.appendChild(text)
  li.appendChild(pre)

  const agreeButton = document.createElement('button')
  agreeButton.innerHTML = '同意'
  agreeButton.style.margin = '0 10px'
  agreeButton.addEventListener('click', function () {
    webAgent.responseUrgent(serialNumber, userId, true)
    removeParent(agreeButton)
  })
  li.appendChild(agreeButton)

  const refuseButton = document.createElement('button')
  refuseButton.innerHTML = '拒绝'
  agreeButton.style.margin = '0 10px'
  refuseButton.addEventListener('click', function () {
    webAgent.responseUrgent(serialNumber, userId, false)
    removeParent(refuseButton)
  })
  li.appendChild(refuseButton)

  list.appendChild(li)
}

function removeParent (node) {
  const parent = node.parentNode
  parent.parentNode.removeChild(parent)
}

function risk () {
  const button = document.getElementById('risk-button')
  if (button.innerHTML === '打开风险揭示') {
    webAgent.risk(true)
    button.innerHTML = '关闭风险揭示'
  } else {
    webAgent.risk(false)
    button.innerHTML = '打开风险揭示'
  }
}

function applyPause() {
  console.log(button.apply.innerHTML)
  switch (button.apply.innerHTML) {
    case '示忙':
      webAgent.applyPause(true)
      break
    case '示闲':
      webAgent.applyPause(false)
      break
  }
}

function checkInOrOut() {
  const button = document.getElementById('check-button')
  button.disabled = true
  button.backgroundColor = ''
  switch(button.innerHTML) {
    case '登录':
      checkin(_getValue('checkin-userId'), _getValue('checkin-password'), _getValue('checkin-server'))
      break
    case '登出':
      checkout()
      break
  }
}

const dialogs = ['local-record-dialog', 'transfer-call-dialog', 'invite-dialog', 'message-dialog', 'urgent-dialog', 'select-snapshot']

function topMostDialog (id) {
  for (let i = 0; i < dialogs.length; i++) {
    if (dialogs[i] === id) {
      document.getElementById(id).style.zIndex = 10
    } else {
      document.getElementById(dialogs[i]).style.zIndex = '0'
    }
  }
}

function changeHoldButton (hold) {
  const span = document.getElementById('hold-span')
  if (hold) {
    span.innerHTML = '会话保持'
  } else {
    span.innerHTML = '取消保持'
  }
}

function clearMessage () {
  const messageContainer = document.getElementById('message-container')
  messageContainer.innerHTML = ''
}

function clearUrgent () {
  const messageContainer = document.getElementById('urgent-list')
  messageContainer.innerHTML = ''
}